HDU 2955 Robberies 背包概率DP

时间:2023-03-09 09:58:00
HDU 2955  Robberies  背包概率DP
A - Robberies

Time Limit:1000MS     Memory Limit:32768KB     64bit IO Format:%I64d & %I64u

Appoint description:

Description

The aspiring Roy the Robber has seen a lot of American movies, and knows that the bad guys usually gets caught in the end, often because they become too greedy. He has decided to work in the lucrative business of bank robbery only for a short while, before retiring to a comfortable job at a university.

HDU 2955  Robberies  背包概率DP
For
a few months now, Roy has been assessing the security of various banks
and the amount of cash they hold. He wants to make a calculated risk,
and grab as much money as possible.

His mother, Ola, has decided upon a tolerable
probability of getting caught. She feels that he is safe enough if the
banks he robs together give a probability less than this.

Input

The first line of input gives T, the number of cases. For each
scenario, the first line of input gives a floating point number P, the
probability Roy needs to be below, and an integer N, the number of banks
he has plans for. Then follow N lines, where line j gives an integer Mj
and a floating point number Pj .

Bank j contains Mj millions, and the probability of getting caught from robbing it is Pj .

Output

For each test case, output a line with the maximum number of millions
he can expect to get while the probability of getting caught is less
than the limit set.

Notes and Constraints
0 < T <= 100
0.0 <= P <= 1.0
0 < N <= 100
0 < Mj <= 100
0.0 <= Pj <= 1.0
A bank goes bankrupt if it is robbed, and you may assume that all
probabilities are independent as the police have very low funds.

Sample Input

3
0.04 3
1 0.02
2 0.03
3 0.05
0.06 3
2 0.03
2 0.03
3 0.05
0.10 3
1 0.03
2 0.02
3 0.05

Sample Output

2
4
6
这是一道01背包的问题,但是有一个地方我没有想到,所以花了很多时间。

  题目给了每个银行的钱和被抓的概率,由于要抢尽量多的钱,所以要保证尽量不被抓,而抢多个银行之后不被抓的概率是抢每一个银行不被抓的概率之 积,我竟然把这一点给忘了!导致我走了许多弯路,思路不能太死啊!dp[]表示抢到下标所对应的钱时,此时不被抓的概率,题目给出了最终不能高于被抓概率 P,不被抓的概率就不能低于(1-P),所以最后只需要逆序遍历dp,找到第一个大于等于1-P的dp[i],就能够保证i最大,即抢到的钱最多。

   /* ***********************************************
Author :Mubaixu
File Name :HDU2955.cpp
************************************************ */ #include<stdio.h>
#include<string.h>
#include<iostream>
#include<queue>
#include<algorithm>
using namespace std;
const int maxm=;
const int maxn=;
double dp[maxm];
int value[maxn];
double tp[maxn];
int main(){
int t;
int n;
double p;
scanf("%d",&t);
while(t--){
scanf("%lf%d",&p,&n); int sum=;
for(int i=;i<=n;i++){
scanf("%d%lf",&value[i],&tp[i]);
tp[i]=-tp[i];
sum+=value[i];
}
memset(dp,,sizeof(dp));
dp[]=; for(int i=;i<=n;i++){
for(int j=sum;j>=value[i];j--){
dp[j]=max(dp[j],dp[j-value[i]]*tp[i]);
}
}
for(int i=sum;i>=;i--){
if(dp[i]>(-p)){
printf("%d\n",i);
break;
} } }
return ;
}